OGRE: Ogre::ParticleSystem Class Reference - OGRE Documentation

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | Static Protected Attributes

# Ogre::ParticleSystem Class Reference
[Effects]

Class defining particle system based special effects. More...

`#include <OgreParticleSystem.h>`

Inheritance diagram for Ogre::ParticleSystem:
[legend]

List of all members.

## Classes
class | CmdCull
| Command object for cull_each (see ParamCommand). More...
class | CmdEmittedEmitterQuota
| Command object for emittedEmitterQuota (see ParamCommand). More...
class | CmdHeight
| Command object for particle_height (see ParamCommand). More...
class | CmdIterationInterval
| Command object for iteration interval(see ParamCommand). More...
class | CmdLocalSpace
| Command object for local space (see ParamCommand). More...
class | CmdMaterial
| Command object for material (see ParamCommand). More...
class | CmdNonvisibleTimeout
| Command object for nonvisible timeout (see ParamCommand). More...
class | CmdQuota
| Command object for quota (see ParamCommand). More...
class | CmdRenderer
| Command object for renderer (see ParamCommand). More...
class | CmdSorted
| Command object for sorting (see ParamCommand). More...
class | CmdWidth
| Command object for particle_width (see ParamCommand). More...
struct | SortByDirectionFunctor
| Sort by direction functor. More...
struct | SortByDistanceFunctor
| Sort by distance functor. More...
## Public Types
typedef vector < ShadowRenderable * >::type | ShadowRenderableList
typedef VectorIterator < ShadowRenderableList > | ShadowRenderableListIterator
## Public Member Functions
| ParticleSystem ()
| Default constructor required for STL creation in manager.
| ParticleSystem (const String &name, const String &resourceGroupName)
| Creates a particle system with no emitters or affectors.
virtual | ~ParticleSystem ()
void | setRenderer (const String &typeName)
| Sets the ParticleRenderer to be used to render this particle system.
ParticleSystemRenderer * | getRenderer (void) const
| Gets the ParticleRenderer to be used to render this particle system.
const String & | getRendererName (void) const
| Gets the name of the ParticleRenderer to be used to render this particle system.
ParticleEmitter * | addEmitter (const String &emitterType)
| Adds an emitter to this particle system.
ParticleEmitter * | getEmitter (unsigned short index) const
| Retrieves an emitter by it's index (zero-based).
unsigned short | getNumEmitters (void) const
| Returns the number of emitters for this particle system.
void | removeEmitter (unsigned short index)
| Removes an emitter from the system.
void | removeAllEmitters (void)
| Removes all the emitters from this system.
ParticleAffector * | addAffector (const String &affectorType)
| Adds an affector to this particle system.
ParticleAffector * | getAffector (unsigned short index) const
| Retrieves an affector by it's index (zero-based).
unsigned short | getNumAffectors (void) const
| Returns the number of affectors for this particle system.
void | removeAffector (unsigned short index)
| Removes an affector from the system.
void | removeAllAffectors (void)
| Removes all the affectors from this system.
void | clear ()
| Empties this set of all particles.
size_t | getNumParticles (void) const
| Gets the number of individual particles in the system right now.
Particle * | createParticle (void)
| Manually add a particle to the system.
Particle * | createEmitterParticle (const String &emitterName)
| Manually add an emitter particle to the system.
Particle * | getParticle (size_t index)
| Retrieve a particle from the system for manual tweaking.
size_t | getParticleQuota (void) const
| Returns the maximum number of particles this system is allowed to have active at once.
void | setParticleQuota (size_t quota)
| Sets the maximum number of particles this system is allowed to have active at once.
size_t | getEmittedEmitterQuota (void) const
| Returns the maximum number of emitted emitters this system is allowed to have active at once.
void | setEmittedEmitterQuota (size_t quota)
| Sets the maximum number of emitted emitters this system is allowed to have active at once.
ParticleSystem & | operator= (const ParticleSystem &rhs)
| Assignment operator for copying.
void | _update (Real timeElapsed)
| Updates the particles in the system based on time elapsed.
ParticleIterator | _getIterator (void)
| Returns an iterator for stepping through all particles in this system.
virtual void | setMaterialName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Sets the name of the material to be used for this billboard set.
virtual const String & | getMaterialName (void) const
| Sets the name of the material to be used for this billboard set.
virtual void | _notifyCurrentCamera (Camera *cam)
| Overridden from MovableObject.
void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Overridden from MovableObject.
virtual const AxisAlignedBox & | getBoundingBox (void) const
| Overridden from MovableObject.
virtual Real | getBoundingRadius (void) const
| Overridden from MovableObject.
virtual void | _updateRenderQueue (RenderQueue *queue)
| Overridden from MovableObject.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false)
void | fastForward (Real time, Real interval=0.1)
| Fast-forwards this system by the required number of seconds.
void | setSpeedFactor (Real speedFactor)
| Sets a 'speed factor' on this particle system, which means it scales the elapsed real time which has passed by this factor before passing it to the emitters, affectors, and the particle life calculation.
Real | getSpeedFactor (void) const
| Gets the 'speed factor' on this particle system.
void | setIterationInterval (Real iterationInterval)
| Sets a 'iteration interval' on this particle system.
Real | getIterationInterval (void) const
| Gets a 'iteration interval' on this particle system.
void | setNonVisibleUpdateTimeout (Real timeout)
| Sets when the particle system should stop updating after it hasn't been visible for a while.
Real | getNonVisibleUpdateTimeout (void) const
| Gets when the particle system should stop updating after it hasn't been visible for a while.
const String & | getMovableType (void) const
| Overridden from MovableObject.
virtual void | _notifyParticleResized (void)
| Internal callback used by Particles to notify their parent that they have been resized.
virtual void | _notifyParticleRotated (void)
| Internal callback used by Particles to notify their parent that they have been rotated.
virtual void | setDefaultDimensions (Real width, Real height)
| Sets the default dimensions of the particles in this set.
virtual void | setDefaultWidth (Real width)
| See setDefaultDimensions - this sets 1 component individually.
virtual Real | getDefaultWidth (void) const
| See setDefaultDimensions - this gets 1 component individually.
virtual void | setDefaultHeight (Real height)
| See setDefaultDimensions - this sets 1 component individually.
virtual Real | getDefaultHeight (void) const
| See setDefaultDimensions - this gets 1 component individually.
virtual bool | getCullIndividually (void) const
| Returns whether or not particles in this are tested individually for culling.
virtual void | setCullIndividually (bool cullIndividual)
| Sets whether culling tests particles in this individually as well as in a group.
virtual const String & | getResourceGroupName (void) const
| Return the resource group to be used to load dependent resources.
const String & | getOrigin (void) const
| Get the origin of this particle system, e.g.
void | _notifyOrigin (const String &origin)
| Notify this particle system of it's origin.
void | setRenderQueueGroup (uint8 queueID)
void | setSortingEnabled (bool enabled)
| Set whether or not particles are sorted according to the camera.
bool | getSortingEnabled (void) const
| Gets whether particles are sorted relative to the camera.
void | setBounds (const AxisAlignedBox &aabb)
| Set the (initial) bounds of the particle system manually.
void | setBoundsAutoUpdated (bool autoUpdate, Real stopIn=0.0f)
| Sets whether the bounds will be automatically updated for the life of the particle system.
void | setKeepParticlesInLocalSpace (bool keepLocal)
| Sets whether particles (and any affector effects) remain relative to the node the particle system is attached to.
bool | getKeepParticlesInLocalSpace (void) const
| Gets whether particles (and any affector effects) remain relative to the node the particle system is attached to.
void | _updateBounds (void)
| Internal method for updating the bounds of the particle system.
void | setEmitting (bool v)
| This is used to turn on or off particle emission for this system.
bool | getEmitting () const
| Returns true if the particle system emitting flag is turned on.
uint32 | getTypeFlags (void) const
| Override to return specific type flag.
ParamDictionary * | getParamDictionary (void)
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary (void) const
const ParameterList & | getParameters (void) const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const String & | getName (void) const
| Returns the name of this object.
virtual Node * | getParentNode (void) const
| Returns the node to which this object is attached.
virtual SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
virtual bool | isParentTagPoint () const
| Gets whether the parent node is a TagPoint (or a SceneNode).
virtual bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
virtual void | detachFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const =0
| Get the world bounding box of the caster.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
virtual void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
virtual bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
virtual void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
virtual Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
virtual void | setUserAny (const Any &anything)
virtual const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
virtual void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)
| Sets the render queue group and group priority this entity will be rendered through.
virtual uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity, see setRenderQueueGroup for full details.
virtual const Matrix4 & | _getParentNodeFullTransform (void) const
| return the full transformation of the parent sceneNode or the attachingPoint node
virtual void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
virtual void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeQueryFlags (unsigned long flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
virtual void | setVisibilityFlags (uint32 flags)
| Sets the visiblity flags for this object.
virtual void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
virtual void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
virtual void | setListener (Listener *listener)
| Sets a listener for this object.
virtual Listener * | getListener (void) const
| Gets the current listener for this object.
virtual const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
virtual uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
virtual void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
virtual LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
EdgeData * | getEdgeList (void)
| Define a default implementation of method from ShadowCaster which implements no shadows.
virtual EdgeData * | getEdgeList (void)=0
| Returns details of the edges which might be used to determine a silhouette.
bool | hasEdgeList (void)
| Define a default implementation of method from ShadowCaster which implements no shadows.
virtual bool | hasEdgeList (void)=0
| Returns whether the object has a valid edge list.
ShadowRenderableListIterator | getShadowVolumeRenderableIterator (ShadowTechnique shadowTechnique, const Light *light, HardwareIndexBufferSharedPtr *indexBuffer, bool extrudeVertices, Real extrusionDist, unsigned long flags=0)
| Define a default implementation of method from ShadowCaster which implements no shadows.
virtual ShadowRenderableListIterator | getShadowVolumeRenderableIterator (ShadowTechnique shadowTechnique, const Light *light, HardwareIndexBufferSharedPtr *indexBuffer, bool extrudeVertices, Real extrusionDistance, unsigned long flags=0)=0
| Gets an iterator over the renderables required to render the shadow volume.
const AxisAlignedBox & | getLightCapBounds (void) const
| Overridden member from ShadowCaster.
virtual const AxisAlignedBox & | getLightCapBounds (void) const =0
| Gets the world space bounding box of the light cap.
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Overridden member from ShadowCaster.
virtual const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const =0
| Gets the world space bounding box of the dark cap, as extruded using the light provided.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
bool | getCastShadows (void) const
| Returns whether shadow casting is enabled for this object.
virtual bool | getCastShadows (void) const =0
| Returns whether or not this object currently casts a shadow.
bool | getReceivesShadows ()
| Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.
Real | getPointExtrusionDistance (const Light *l) const
| Get the distance to extrude for a point/spot light.
virtual Real | getPointExtrusionDistance (const Light *l) const =0
| Get the distance to extrude for a point/spot light.
virtual void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
virtual bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info
void * | operator new (size_t sz)
void * | operator new (size_t sz, void *ptr)
| placement operator new
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info
void * | operator new[] (size_t sz)
void | operator delete (void *ptr)
void | operator delete (void *ptr, void *)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
## Static Public Member Functions
static void | setDefaultIterationInterval (Real iterationInterval)
| Set the default iteration interval for all ParticleSystem instances.
static Real | getDefaultIterationInterval (void)
| Get the default iteration interval for all ParticleSystem instances.
static void | setDefaultNonVisibleUpdateTimeout (Real timeout)
| Set the default nonvisible timeout for all ParticleSystem instances.
static Real | getDefaultNonVisibleUpdateTimeout (void)
| Get the default nonvisible timeout for all ParticleSystem instances.
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.
## Protected Types
typedef list< Particle * >::type | ActiveParticleList
typedef list< Particle * >::type | FreeParticleList
typedef vector< Particle * >::type | ParticlePool
typedef list< ParticleEmitter * > ::type | FreeEmittedEmitterList
typedef list< ParticleEmitter * > ::type | ActiveEmittedEmitterList
typedef vector < ParticleEmitter * >::type | EmittedEmitterList
typedef map< String, FreeEmittedEmitterList >::type | FreeEmittedEmitterMap
typedef map< String, EmittedEmitterList >::type | EmittedEmitterPool
typedef vector < ParticleEmitter * >::type | ParticleEmitterList
typedef vector < ParticleAffector * >::type | ParticleAffectorList
typedef map< String, StringVector >::type | AnimableDictionaryMap
## Protected Member Functions
void | _expire (Real timeElapsed)
| Internal method used to expire dead particles.
void | _triggerEmitters (Real timeElapsed)
| Spawn new particles based on free quota and emitter requirements.
void | _executeTriggerEmitters (ParticleEmitter *emitter, unsigned requested, Real timeElapsed)
| Helper function that actually performs the emission of particles.
void | _applyMotion (Real timeElapsed)
| Updates existing particle based on their momentum.
void | _triggerAffectors (Real timeElapsed)
| Applies the effects of affectors.
void | _sortParticles (Camera *cam)
| Sort the particles in the system.
void | increasePool (size_t size)
| Resize the internal pool of particles.
void | increaseEmittedEmitterPool (size_t size)
| Resize the internal pool of emitted emitters.
void | initParameters (void)
| Internal method for initialising string interface.
void | configureRenderer (void)
| Internal method to configure the renderer.
void | createVisualParticles (size_t poolstart, size_t poolend)
| Internal method for creating ParticleVisualData instances for the pool.
void | destroyVisualParticles (size_t poolstart, size_t poolend)
| Internal method for destroying ParticleVisualData instances for the pool.
void | initialiseEmittedEmitters (void)
| Create a pool of emitted emitters and assign them to the free emitter list.
void | initialiseEmittedEmitterPool (void)
| Determine which emitters in the Particle Systems main emitter become a template for creating an pool of emitters that can be emitted.
void | addFreeEmittedEmitters (void)
| Add emitters from the pool to the free emitted emitter queue.
void | removeAllEmittedEmitters (void)
| Removes all emitted emitters from this system.
FreeEmittedEmitterList * | findFreeEmittedEmitter (const String &name)
| Find the list with free emitted emitters.
void | removeFromActiveEmittedEmitters (ParticleEmitter *emitter)
| Removes an emitter from the active emitted emitter list.
void | addActiveEmittedEmittersToFreeList (void)
| Moves all emitted emitters from the active list to the free list.
void | _notifyReorganiseEmittedEmitterData (void)
| This function clears all data structures that are used in combination with emitted emitters and sets the flag to indicate that the emitted emitter pool must be initialised again.
bool | createParamDictionary (const String &className)
| Internal method for creating a parameter dictionary for the class, if it does not already exist.
Real | getExtrusionDistance (const Vector3 &objectPos, const Light *light) const
| Helper method for calculating extrusion distance.
virtual void | updateEdgeListLightFacing (EdgeData *edgeData, const Vector4 &lightPos)
| Tells the caster to perform the tasks necessary to update the edge data's light listing.
virtual void | generateShadowVolume (EdgeData *edgeData, const HardwareIndexBufferSharedPtr &indexBuffer, const Light *light, ShadowRenderableList &shadowRenderables, unsigned long flags)
| Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.
virtual void | extrudeBounds (AxisAlignedBox &box, const Vector4 &lightPos, Real extrudeDist) const
| Utility method for extruding a bounding box.
virtual const String & | getAnimableDictionaryName (void) const
| Get the name of the animable dictionary for this class.
void | createAnimableDictionary (void) const
| Internal method for creating a dictionary of animable value names for the class, if it does not already exist.
StringVector & | _getAnimableValueNames (void)
| Get an updateable reference to animable value list.
virtual void | initialiseAnimableDictionary (StringVector &) const
| Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.
## Protected Attributes
AxisAlignedBox | mAABB
Real | mBoundingRadius
bool | mBoundsAutoUpdate
Real | mBoundsUpdateTime
Real | mUpdateRemainTime
AxisAlignedBox | mWorldAABB
| World AABB, only used to compare world-space positions to calc bounds.
String | mResourceGroupName
| Name of the resource group to use to load materials.
String | mMaterialName
| Name of the material to use.
bool | mIsRendererConfigured
| Have we set the material etc on the renderer?
MaterialPtr | mpMaterial
| Pointer to the material to use.
Real | mDefaultWidth
| Default width of each particle.
Real | mDefaultHeight
| Default height of each particle.
Real | mSpeedFactor
| Speed factor.
Real | mIterationInterval
| Iteration interval.
bool | mIterationIntervalSet
| Iteration interval set? Otherwise track default.
bool | mSorted
| Particles sorted according to camera?
bool | mLocalSpace
| Particles in local space?
Real | mNonvisibleTimeout
| Update timeout when nonvisible (0 for no timeout).
bool | mNonvisibleTimeoutSet
| Update timeout when nonvisible set? Otherwise track default.
Real | mTimeSinceLastVisible
| Amount of time non-visible so far.
unsigned long | mLastVisibleFrame
| Last frame in which known to be visible.
Controller< Real > * | mTimeController
| Controller for time update.
bool | mEmittedEmitterPoolInitialised
| Indication whether the emitted emitter pool (= pool with particle emitters that are emitted) is initialised.
bool | mIsEmitting
| Used to control if the particle system should emit particles or not.
ActiveParticleList | mActiveParticles
| Active particle list.
FreeParticleList | mFreeParticles
| Free particle queue.
ParticlePool | mParticlePool
| Pool of particle instances for use and reuse in the active particle list.
EmittedEmitterPool | mEmittedEmitterPool
| Pool of emitted emitters for use and reuse in the active emitted emitter list.
FreeEmittedEmitterMap | mFreeEmittedEmitters
| Free emitted emitter list.
ActiveEmittedEmitterList | mActiveEmittedEmitters
| Active emitted emitter list.
ParticleEmitterList | mEmitters
| List of particle emitters, ie sources of particles.
ParticleAffectorList | mAffectors
| List of particle affectors, ie modifiers of particles.
ParticleSystemRenderer * | mRenderer
| The renderer used to render this particle system.
bool | mCullIndividual
| Do we cull each particle individually?
String | mRendererType
| The name of the type of renderer used to render this system.
size_t | mPoolSize
| The number of particles in the pool.
size_t | mEmittedEmitterPoolSize
| The number of emitted emitters in the pool.
String | mOrigin
| Optional origin of this particle system (eg script name).
String | mName
| Name of this object.
MovableObjectFactory * | mCreator
| Creator of this object (if created by a factory).
SceneManager * | mManager
| SceneManager holding this object (if applicable).
Node * | mParentNode
| node to which this object is attached
bool | mParentIsTagPoint
bool | mVisible
| Is this object visible?
bool | mDebugDisplay
| Is debug display enabled?
Real | mUpperDistance
| Upper distance to still render.
Real | mSquaredUpperDistance
bool | mBeyondFarDistance
| Hidden because of distance?
UserObjectBindings | mUserObjectBindings
| User objects binding.
uint8 | mRenderQueueID
| The render queue to use when rendering this object.
bool | mRenderQueueIDSet
| Flags whether the RenderQueue's default should be used.
ushort | mRenderQueuePriority
| The render queue group to use when rendering this object.
bool | mRenderQueuePrioritySet
| Flags whether the RenderQueue's default should be used.
uint32 | mQueryFlags
| Flags determining whether this object is included / excluded from scene queries.
uint32 | mVisibilityFlags
| Flags determining whether this object is visible (compared to SceneManager mask).
Sphere | mWorldBoundingSphere
AxisAlignedBox | mWorldDarkCapBounds
| World space AABB of this object's dark cap.
bool | mCastShadows
| Does this object cast shadows?
bool | mRenderingDisabled
| Does rendering this object disabled by listener?
Listener * | mListener
| MovableObject listener - only one allowed (no list) for size & performance reasons. */.
LightList | mLightList
| List of lights for this object.
ulong | mLightListUpdated
| The last frame that this light list was updated in.
uint32 | mLightMask
| the light mask defined for this movable. This will be taken into consideration when deciding which light should affect this movable
## Static Protected Attributes
static CmdCull | msCullCmd
| Command objects.
static CmdHeight | msHeightCmd
static CmdMaterial | msMaterialCmd
static CmdQuota | msQuotaCmd
static CmdEmittedEmitterQuota | msEmittedEmitterQuotaCmd
static CmdWidth | msWidthCmd
static CmdRenderer | msRendererCmd
static CmdSorted | msSortedCmd
static CmdLocalSpace | msLocalSpaceCmd
static CmdIterationInterval | msIterationIntervalCmd
static CmdNonvisibleTimeout | msNonvisibleTimeoutCmd
static RadixSort < ActiveParticleList, Particle *, float > | mRadixSorter
static Real | msDefaultIterationInterval
| Default iteration interval.
static Real | msDefaultNonvisibleTimeout
| Default nonvisible update timeout.
static uint32 | msDefaultQueryFlags
| Default query flags.
static uint32 | msDefaultVisibilityFlags
| Default visibility flags.
static AnimableDictionaryMap | msAnimableDictionary
| Static map of class name to list of animable value names.

## Detailed Description

Class defining particle system based special effects.

Remarks:
  Particle systems are special effects generators which are based on a number of moving points to create the impression of things like like sparkles, smoke, blood spurts, dust etc.

  This class simply manages a single collection of particles in world space with a shared local origin for emission. The visual aspect of the particles is handled by a ParticleSystemRenderer instance.

  Particle systems are created using the SceneManager, never directly. In addition, like all subclasses of MovableObject, the ParticleSystem will only be considered for rendering once it has been attached to a SceneNode.

Definition at line 66 of file OgreParticleSystem.h.

## Member Typedef Documentation

typedef list<ParticleEmitter*>::type Ogre::ParticleSystem::ActiveEmittedEmitterList`[protected]`

Definition at line 758 of file OgreParticleSystem.h.

typedef list<Particle*>::type Ogre::ParticleSystem::ActiveParticleList`[protected]`

Definition at line 703 of file OgreParticleSystem.h.

typedef map<String, StringVector>::type Ogre::AnimableObject::AnimableDictionaryMap`[protected, inherited]`

Definition at line 240 of file OgreAnimable.h.

typedef vector<ParticleEmitter*>::type Ogre::ParticleSystem::EmittedEmitterList`[protected]`

Definition at line 759 of file OgreParticleSystem.h.

typedef map<String, EmittedEmitterList>::type Ogre::ParticleSystem::EmittedEmitterPool`[protected]`

Definition at line 761 of file OgreParticleSystem.h.

typedef list<ParticleEmitter*>::type Ogre::ParticleSystem::FreeEmittedEmitterList`[protected]`

Definition at line 757 of file OgreParticleSystem.h.

typedef map<String, FreeEmittedEmitterList>::type Ogre::ParticleSystem::FreeEmittedEmitterMap`[protected]`

Definition at line 760 of file OgreParticleSystem.h.

typedef list<Particle*>::type Ogre::ParticleSystem::FreeParticleList`[protected]`

Definition at line 704 of file OgreParticleSystem.h.

typedef vector<ParticleAffector*>::type Ogre::ParticleSystem::ParticleAffectorList`[protected]`

Definition at line 787 of file OgreParticleSystem.h.

typedef vector<ParticleEmitter*>::type Ogre::ParticleSystem::ParticleEmitterList`[protected]`

Definition at line 786 of file OgreParticleSystem.h.

typedef vector<Particle*>::type Ogre::ParticleSystem::ParticlePool`[protected]`

Definition at line 705 of file OgreParticleSystem.h.

typedef vector<ShadowRenderable*>::type Ogre::ShadowCaster::ShadowRenderableList`[inherited]`

Definition at line 128 of file OgreShadowCaster.h.

typedef VectorIterator<ShadowRenderableList> Ogre::ShadowCaster::ShadowRenderableListIterator`[inherited]`

Definition at line 129 of file OgreShadowCaster.h.

## Constructor & Destructor Documentation

Ogre::ParticleSystem::ParticleSystem | ( |  | ) |

Default constructor required for STL creation in manager.

Ogre::ParticleSystem::ParticleSystem | ( | const String & | name,
|  | const String & | resourceGroupName |
| ) |  |  |

Creates a particle system with no emitters or affectors.

Remarks:
  You should use the ParticleSystemManager to create particle systems rather than creating them directly.

virtual Ogre::ParticleSystem::~ParticleSystem | ( |  | ) | `[virtual]`

## Member Function Documentation

void Ogre::ParticleSystem::_applyMotion | ( | Real | timeElapsed | ) | `[protected]`

Updates existing particle based on their momentum.

void Ogre::ParticleSystem::_executeTriggerEmitters | ( | ParticleEmitter * | emitter,
|  | unsigned | requested,
|  | Real | timeElapsed |
| ) |  |  | `[protected]`

Helper function that actually performs the emission of particles.

void Ogre::ParticleSystem::_expire | ( | Real | timeElapsed | ) | `[protected]`

Internal method used to expire dead particles.

StringVector& Ogre::AnimableObject::_getAnimableValueNames | ( | void |  | ) | `[protected, inherited]`

Get an updateable reference to animable value list.

Definition at line 266 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

virtual MovableObjectFactory* Ogre::MovableObject::_getCreator | ( | void |  | ) | const`[virtual, inherited]`

Get the creator of this object, if any (internal use only).

Definition at line 183 of file OgreMovableObject.h.

ParticleIterator Ogre::ParticleSystem::_getIterator | ( | void |  | ) |

Returns an iterator for stepping through all particles in this system.

Remarks:
  This method is designed to be used by people providing new ParticleAffector subclasses, this is the easiest way to step through all the particles in a system and apply the changes the affector wants to make.

virtual LightList* Ogre::MovableObject::_getLightList | ( |  | ) | `[virtual, inherited]`

Returns a pointer to the current list of lights for this object.

Remarks:
  You should not modify this list outside of MovableObject::Listener::objectQueryLights (say if you want to use it to implement this method, and use the pointer as a return value) and for reading it's only accurate as at the last frame.

Definition at line 472 of file OgreMovableObject.h.

virtual SceneManager* Ogre::MovableObject::_getManager | ( | void |  | ) | const`[virtual, inherited]`

Get the manager of this object, if any (internal use only).

Definition at line 187 of file OgreMovableObject.h.

virtual const Matrix4& Ogre::MovableObject::_getParentNodeFullTransform | ( | void |  | ) | const`[virtual, inherited]`

return the full transformation of the parent sceneNode or the attachingPoint node

void Ogre::ParticleSystem::_notifyAttached | ( | Node * | parent,
|  | bool | isTagPoint = `false` |
| ) |  |  | `[virtual]`

Overridden from MovableObject.

See also:
  MovableObject

Reimplemented from Ogre::MovableObject.

virtual void Ogre::MovableObject::_notifyCreator | ( | MovableObjectFactory * | fact | ) | `[virtual, inherited]`

Notify the object of it's creator (internal use only).

Definition at line 181 of file OgreMovableObject.h.

virtual void Ogre::ParticleSystem::_notifyCurrentCamera | ( | Camera * | cam | ) | `[virtual]`

Overridden from MovableObject.

See also:
  MovableObject

Reimplemented from Ogre::MovableObject.

virtual void Ogre::MovableObject::_notifyManager | ( | SceneManager * | man | ) | `[virtual, inherited]`

Notify the object of it's manager (internal use only).

Definition at line 185 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::_notifyMoved | ( | void |  | ) | `[virtual, inherited]`

Internal method called to notify the object that it has been moved.

Reimplemented in Ogre::Light.

void Ogre::ParticleSystem::_notifyOrigin | ( | const String & | origin | ) |

Notify this particle system of it's origin.

Definition at line 546 of file OgreParticleSystem.h.

virtual void Ogre::ParticleSystem::_notifyParticleResized | ( | void |  | ) | `[virtual]`

Internal callback used by Particles to notify their parent that they have been resized.

virtual void Ogre::ParticleSystem::_notifyParticleRotated | ( | void |  | ) | `[virtual]`

Internal callback used by Particles to notify their parent that they have been rotated.

void Ogre::ParticleSystem::_notifyReorganiseEmittedEmitterData | ( | void |  | ) | `[protected]`

This function clears all data structures that are used in combination with emitted emitters and sets the flag to indicate that the emitted emitter pool must be initialised again.

Remarks:
  This function should be called if new emitters are added to a ParticleSystem or deleted from a ParticleSystem. The emitted emitter data structures become out of sync and need to be build up again. The data structures are not reorganised in this function, but by setting a flag, they are rebuild in the regular process flow.

void Ogre::ParticleSystem::_sortParticles | ( | Camera * | cam | ) | `[protected]`

Sort the particles in the system.

void Ogre::ParticleSystem::_triggerAffectors | ( | Real | timeElapsed | ) | `[protected]`

Applies the effects of affectors.

void Ogre::ParticleSystem::_triggerEmitters | ( | Real | timeElapsed | ) | `[protected]`

Spawn new particles based on free quota and emitter requirements.

void Ogre::ParticleSystem::_update | ( | Real | timeElapsed | ) |

Updates the particles in the system based on time elapsed.

Remarks:
  This is called automatically every frame by OGRE.

Parameters:

  | timeElapsed | The amount of time, in seconds, since the last frame.

void Ogre::ParticleSystem::_updateBounds | ( | void |  | ) |

Internal method for updating the bounds of the particle system.

Remarks:
  This is called automatically for a period of time after the system's creation (10 seconds by default, settable by setBoundsAutoUpdated) to increase (and only increase) the bounds of the system according to the emitted and affected particles. After this period, the system is assumed to achieved its maximum size, and the bounds are no longer computed for efficiency. You can tweak the behaviour by either setting the bounds manually (setBounds, preferred), or changing the time over which the bounds are updated (performance cost). You can also call this method manually if you need to update the bounds on an ad-hoc basis.

virtual void Ogre::ParticleSystem::_updateRenderQueue | ( | RenderQueue * | queue | ) | `[virtual]`

Overridden from MovableObject.

See also:
  MovableObject

Implements Ogre::MovableObject.

void Ogre::ParticleSystem::addActiveEmittedEmittersToFreeList | ( | void |  | ) | `[protected]`

Moves all emitted emitters from the active list to the free list.

Remarks:
  The active emitted emitter list will not be cleared and still keeps references to the emitters!

ParticleAffector* Ogre::ParticleSystem::addAffector | ( | const String & | affectorType | ) |

Adds an affector to this particle system.

Remarks:
  Particles are modified over time in a particle system by affectors - see the ParticleAffector class for more details.

Parameters:

  | affectorType | String identifying the affector type to create. Affector types are defined by registering new factories with the manager - see ParticleAffectorFactory for more details. Affector types can be extended by OGRE, plugin authors or application developers.

ParticleEmitter* Ogre::ParticleSystem::addEmitter | ( | const String & | emitterType | ) |

Adds an emitter to this particle system.

Remarks:
  Particles are created in a particle system by emitters - see the ParticleEmitter class for more details.

Parameters:

  | emitterType | String identifying the emitter type to create. Emitter types are defined by registering new factories with the manager - see ParticleEmitterFactory for more details. Emitter types can be extended by OGRE, plugin authors or application developers.

void Ogre::ParticleSystem::addFreeEmittedEmitters | ( | void |  | ) | `[protected]`

Add emitters from the pool to the free emitted emitter queue.

virtual void Ogre::MovableObject::addQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.

Definition at line 377 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::addVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.

Definition at line 405 of file OgreMovableObject.h.

static void Ogre::StringInterface::cleanupDictionary | ( |  | ) | `[static, inherited]`

Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.

MaterialManager) initializes.

void Ogre::ParticleSystem::clear | ( |  | ) |

Empties this set of all particles.

void Ogre::ParticleSystem::configureRenderer | ( | void |  | ) | `[protected]`

Internal method to configure the renderer.

virtual void Ogre::StringInterface::copyParametersTo | ( | StringInterface * | dest | ) | const`[virtual, inherited]`

Method for copying this object's parameters to another object.

Remarks:
  This method takes the values of all the object's parameters and tries to set the same values on the destination object. This provides a completely type independent way to copy parameters to other objects. Note that because of the String manipulation involved, this should not be regarded as an efficient process and should be saved for times outside of the rendering loop.

  Any unrecognised parameters will be ignored as with setParameter method.

Parameters:

  | dest | Pointer to object to have it's parameters set the same as this object.

Definition at line 301 of file OgreStringInterface.h.

References Ogre::ParamDictionary::mParamDefs, and Ogre::StringInterface::setParameter().

void Ogre::AnimableObject::createAnimableDictionary | ( | void |  | ) | const`[protected, inherited]`

Internal method for creating a dictionary of animable value names for the class, if it does not already exist.

Definition at line 253 of file OgreAnimable.h.

virtual AnimableValuePtr Ogre::AnimableObject::createAnimableValue | ( | const String & | valueName | ) | `[virtual, inherited]`

Create a reference-counted AnimableValuePtr for the named value.

Remarks:
  You can use the returned object to animate a value on this object, using AnimationTrack. Subclasses must override this if they wish to support animation of their values.

Definition at line 319 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

Particle* Ogre::ParticleSystem::createEmitterParticle | ( | const String & | emitterName | ) |

Manually add an emitter particle to the system.

Remarks:
  The purpose of a particle emitter is to emit particles. Besides visual particles, also other other particle types can be emitted, other emitters for example. The emitted emitters have a double role; they behave as particles and can be influenced by affectors, but they are still emitters and capable to emit other particles (or emitters). It is possible to create a chain of emitters - emitters emitting other emitters, which also emit emitters.

Parameters:

  | emitterName | The name of a particle emitter that must be emitted.

bool Ogre::StringInterface::createParamDictionary | ( | const String & | className | ) | `[protected, inherited]`

Internal method for creating a parameter dictionary for the class, if it does not already exist.

Remarks:
  This method will check to see if a parameter dictionary exist for this class yet, and if not will create one. NB you must supply the name of the class (RTTI is not used or performance).

Parameters:

  | className | the name of the class using the dictionary

Returns:
  true if a new dictionary was created, false if it was already there

Definition at line 184 of file OgreStringInterface.h.

References OGRE_LOCK_MUTEX.

Particle* Ogre::ParticleSystem::createParticle | ( | void |  | ) |

Manually add a particle to the system.

Remarks:
  Instead of using an emitter, you can manually add a particle to the system. You must initialise the returned particle instance immediately with the 'emission' state.

Note:
  There is no corresponding 'destroyParticle' method - if you want to dispose of a particle manually (say, if you've used setSpeedFactor(0) to make particles live forever) you should use getParticle() and modify it's timeToLive to zero, meaning that it will get cleaned up in the next update.

void Ogre::ParticleSystem::createVisualParticles | ( | size_t | poolstart,
|  | size_t | poolend |
| ) |  |  | `[protected]`

Internal method for creating ParticleVisualData instances for the pool.

void Ogre::ParticleSystem::destroyVisualParticles | ( | size_t | poolstart,
|  | size_t | poolend |
| ) |  |  | `[protected]`

Internal method for destroying ParticleVisualData instances for the pool.

virtual void Ogre::MovableObject::detachFromParent | ( | void |  | ) | `[virtual, inherited]`

Detaches an object from a parent SceneNode or TagPoint, if attached.

virtual void Ogre::ShadowCaster::extrudeBounds | ( | AxisAlignedBox & | box,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist |
| ) |  |  | const`[protected, virtual, inherited]`

Utility method for extruding a bounding box.

Parameters:

  | box | Original bounding box, will be updated in-place
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

static void Ogre::ShadowCaster::extrudeVertices | ( | const HardwareVertexBufferSharedPtr & | vertexBuffer,
|  | size_t | originalVertexCount,
|  | const Vector4 & | lightPos,
|  | Real | extrudeDist |
| ) |  |  | `[static, inherited]`

Utility method for extruding vertices based on a light.

Remarks:
  Unfortunately, because D3D cannot handle homogeneous (4D) position coordinates in the fixed-function pipeline (GL can, but we have to be cross-API), when we extrude in software we cannot extrude to infinity the way we do in the vertex program (by setting w to 0.0f). Therefore we extrude by a fixed distance, which may cause some problems with larger scenes. Luckily better hardware (ie vertex programs) can fix this.

Parameters:

  | vertexBuffer | The vertex buffer containing ONLY xyz position values, which must be originalVertexCount * 2 * 3 floats long.
  | originalVertexCount | The count of the original number of vertices, i.e. the number in the mesh, not counting the doubling which has already been done (by VertexData::prepareForShadowVolume) to provide the extruded area of the buffer.
  | lightPos | 4D light position in object space, when w=0.0f this represents a directional light
  | extrudeDist | The distance to extrude

void Ogre::ParticleSystem::fastForward | ( | Real | time,
|  | Real | interval = `0.1` |
| ) |  |  |

Fast-forwards this system by the required number of seconds.

Remarks:
  This method allows you to fast-forward a system so that it effectively looks like it has already been running for the time you specify. This is useful to avoid the 'startup sequence' of a system, when you want the system to be fully populated right from the start.

Parameters:

  | time | The number of seconds to fast-forward by.
  | interval | The sampling interval used to generate particles, apply affectors etc. The lower this is the more realistic the fast-forward, but it takes more iterations to do it.

FreeEmittedEmitterList* Ogre::ParticleSystem::findFreeEmittedEmitter | ( | const String & | name | ) | `[protected]`

Find the list with free emitted emitters.

Parameters:

  | name | The name that identifies the list with free emitted emitters.

virtual void Ogre::ShadowCaster::generateShadowVolume | ( | EdgeData * | edgeData,
|  | const HardwareIndexBufferSharedPtr & | indexBuffer,
|  | const Light * | light,
|  | ShadowRenderableList & | shadowRenderables,
|  | unsigned long | flags |
| ) |  |  | `[protected, virtual, inherited]`

Generates the indexes required to render a shadow volume into the index buffer which is passed in, and updates shadow renderables to use it.

Parameters:

  | edgeData | The edge information to use
  | indexBuffer | The buffer into which to write data into; current contents are assumed to be discardable.
  | light | The light, mainly for type info as silhouette calculations should already have been done in updateEdgeListLightFacing
  | shadowRenderables | A list of shadow renderables which has already been constructed but will need populating with details of the index ranges to be used.
  | flags | Additional controller flags, see ShadowRenderableFlags

ParticleAffector* Ogre::ParticleSystem::getAffector | ( | unsigned short | index | ) | const

Retrieves an affector by it's index (zero-based).

Remarks:
  Used to retrieve a pointer to an affector for a particle system to procedurally change affector parameters etc. You should check how many affectors are registered against this system before calling this method with an arbitrary index using getNumAffectors.

Parameters:

  | index | Zero-based index of the affector to retrieve.

virtual const String& Ogre::AnimableObject::getAnimableDictionaryName | ( | void |  | ) | const`[protected, virtual, inherited]`

Get the name of the animable dictionary for this class.

Remarks:
  Subclasses must override this if they want to support animation of their values.

Definition at line 248 of file OgreAnimable.h.

References Ogre::StringUtil::BLANK.

const StringVector& Ogre::AnimableObject::getAnimableValueNames | ( | void |  | ) | const`[inherited]`

Gets a list of animable value names for this object.

Definition at line 294 of file OgreAnimable.h.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

virtual const AxisAlignedBox& Ogre::ParticleSystem::getBoundingBox | ( | void |  | ) | const`[virtual]`

Overridden from MovableObject.

See also:
  MovableObject

Implements Ogre::MovableObject.

Definition at line 378 of file OgreParticleSystem.h.

virtual Real Ogre::ParticleSystem::getBoundingRadius | ( | void |  | ) | const`[virtual]`

Overridden from MovableObject.

See also:
  MovableObject

Implements Ogre::MovableObject.

Definition at line 384 of file OgreParticleSystem.h.

bool Ogre::MovableObject::getCastShadows | ( | void |  | ) | const`[inherited]`

Returns whether shadow casting is enabled for this object.

Reimplemented in Ogre::TerrainQuadTreeNode::Movable.

Definition at line 502 of file OgreMovableObject.h.

virtual bool Ogre::ShadowCaster::getCastShadows | ( | void |  | ) | const`[pure virtual, inherited]`

Returns whether or not this object currently casts a shadow.

virtual bool Ogre::ParticleSystem::getCullIndividually | ( | void |  | ) | const`[virtual]`

Returns whether or not particles in this are tested individually for culling.

const AxisAlignedBox& Ogre::MovableObject::getDarkCapBounds | ( | const Light & | light,
|  | Real | dirLightExtrusionDist |
| ) |  |  | const`[inherited]`

Overridden member from ShadowCaster.

virtual const AxisAlignedBox& Ogre::ShadowCaster::getDarkCapBounds | ( | const Light & | light,
|  | Real | dirLightExtrusionDist |
| ) |  |  | const`[pure virtual, inherited]`

Gets the world space bounding box of the dark cap, as extruded using the light provided.

virtual Real Ogre::ParticleSystem::getDefaultHeight | ( | void |  | ) | const`[virtual]`

See setDefaultDimensions - this gets 1 component individually.

static Real Ogre::ParticleSystem::getDefaultIterationInterval | ( | void |  | ) | `[static]`

Get the default iteration interval for all ParticleSystem instances.

Definition at line 451 of file OgreParticleSystem.h.

static Real Ogre::ParticleSystem::getDefaultNonVisibleUpdateTimeout | ( | void |  | ) | `[static]`

Get the default nonvisible timeout for all ParticleSystem instances.

Definition at line 480 of file OgreParticleSystem.h.

static uint32 Ogre::MovableObject::getDefaultQueryFlags | ( |  | ) | `[static, inherited]`

Get the default query flags for all future MovableObject instances.

Definition at line 392 of file OgreMovableObject.h.

static uint32 Ogre::MovableObject::getDefaultVisibilityFlags | ( |  | ) | `[static, inherited]`

Get the default visibility flags for all future MovableObject instances.

Definition at line 420 of file OgreMovableObject.h.

virtual Real Ogre::ParticleSystem::getDefaultWidth | ( | void |  | ) | const`[virtual]`

See setDefaultDimensions - this gets 1 component individually.

EdgeData* Ogre::MovableObject::getEdgeList | ( | void |  | ) | `[inherited]`

Define a default implementation of method from ShadowCaster which implements no shadows.

Reimplemented in Ogre::ManualObject, and Ogre::StaticGeometry::Region.

Definition at line 475 of file OgreMovableObject.h.

virtual EdgeData* Ogre::ShadowCaster::getEdgeList | ( | void |  | ) | `[pure virtual, inherited]`

Returns details of the edges which might be used to determine a silhouette.

size_t Ogre::ParticleSystem::getEmittedEmitterQuota | ( | void |  | ) | const

Returns the maximum number of emitted emitters this system is allowed to have active at once.

Remarks:
  See ParticleSystem::setEmittedEmitterQuota for more info.

ParticleEmitter* Ogre::ParticleSystem::getEmitter | ( | unsigned short | index | ) | const

Retrieves an emitter by it's index (zero-based).

Remarks:
  Used to retrieve a pointer to an emitter for a particle system to procedurally change emission parameters etc. You should check how many emitters are registered against this system before calling this method with an arbitrary index using getNumEmitters.

Parameters:

  | index | Zero-based index of the emitter to retrieve.

bool Ogre::ParticleSystem::getEmitting | ( |  | ) | const

Returns true if the particle system emitting flag is turned on.

Remarks:
  This function will not actually return whether the particles are being emitted. It only returns the value of emitting flag.

Real Ogre::ShadowCaster::getExtrusionDistance | ( | const Vector3 & | objectPos,
|  | const Light * | light |
| ) |  |  | const`[protected, inherited]`

Helper method for calculating extrusion distance.

Real Ogre::ParticleSystem::getIterationInterval | ( | void |  | ) | const

Gets a 'iteration interval' on this particle system.

Definition at line 443 of file OgreParticleSystem.h.

bool Ogre::ParticleSystem::getKeepParticlesInLocalSpace | ( | void |  | ) | const

Gets whether particles (and any affector effects) remain relative to the node the particle system is attached to.

Definition at line 604 of file OgreParticleSystem.h.

const AxisAlignedBox& Ogre::MovableObject::getLightCapBounds | ( | void |  | ) | const`[inherited]`

Overridden member from ShadowCaster.

virtual const AxisAlignedBox& Ogre::ShadowCaster::getLightCapBounds | ( | void |  | ) | const`[pure virtual, inherited]`

Gets the world space bounding box of the light cap.

virtual uint32 Ogre::MovableObject::getLightMask | ( |  | ) | const`[virtual, inherited]`

Get a bitwise mask which will filter the lights affecting this object.

Remarks:
  By default, this mask is fully set meaning all lights will affect this object

Definition at line 457 of file OgreMovableObject.h.

virtual Listener* Ogre::MovableObject::getListener | ( | void |  | ) | const`[virtual, inherited]`

Gets the current listener for this object.

Definition at line 431 of file OgreMovableObject.h.

virtual const String& Ogre::ParticleSystem::getMaterialName | ( | void |  | ) | const`[virtual]`

Sets the name of the material to be used for this billboard set.

Returns:
  The name of the material that is used for this set.

const String& Ogre::ParticleSystem::getMovableType | ( | void |  | ) | const`[virtual]`

Overridden from MovableObject.

Implements Ogre::MovableObject.

virtual const String& Ogre::MovableObject::getName | ( | void |  | ) | const`[virtual, inherited]`

Returns the name of this object.

Definition at line 190 of file OgreMovableObject.h.

Real Ogre::ParticleSystem::getNonVisibleUpdateTimeout | ( | void |  | ) | const

Gets when the particle system should stop updating after it hasn't been visible for a while.

Definition at line 471 of file OgreParticleSystem.h.

unsigned short Ogre::ParticleSystem::getNumAffectors | ( | void |  | ) | const

Returns the number of affectors for this particle system.

unsigned short Ogre::ParticleSystem::getNumEmitters | ( | void |  | ) | const

Returns the number of emitters for this particle system.

size_t Ogre::ParticleSystem::getNumParticles | ( | void |  | ) | const

Gets the number of individual particles in the system right now.

Remarks:
  The number of particles active in a system at a point in time depends on the number of emitters, their emission rates, the time-to-live (TTL) each particle is given on emission (and whether any affectors modify that TTL) and the maximum number of particles allowed in this system at once (particle quota).

const String& Ogre::ParticleSystem::getOrigin | ( | void |  | ) | const

Get the origin of this particle system, e.g.

a script file name.

Remarks:
  This property will only contain something if the creator of this particle system chose to populate it. Script loaders are advised to populate it.

Definition at line 544 of file OgreParticleSystem.h.

ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | `[inherited]`

Retrieves the parameter dictionary for this class.

Remarks:
  Only valid to call this after createParamDictionary.

Returns:
  Pointer to ParamDictionary shared by all instances of this class which you can add parameters to, retrieve parameters etc.

Definition at line 217 of file OgreStringInterface.h.

const ParamDictionary* Ogre::StringInterface::getParamDictionary | ( | void |  | ) | const`[inherited]`

Definition at line 222 of file OgreStringInterface.h.

virtual String Ogre::StringInterface::getParameter | ( | const String & | name | ) | const`[virtual, inherited]`

Generic parameter retrieval method.

Remarks:
  Call this method with the name of a parameter to retrieve a string-format value of the parameter in question. If in doubt, check the parameter definition in the list returned from getParameters for the type of this parameter. If you like you can use StringConverter to convert this string back into a native type.

Parameters:

  | name | The name of the parameter to get

Returns:
  String value of parameter, blank if not found

Definition at line 270 of file OgreStringInterface.h.

References Ogre::ParamCommand::doGet(), and Ogre::ParamDictionary::getParamCommand().

const ParameterList& Ogre::StringInterface::getParameters | ( | void |  | ) | const`[inherited]`

Retrieves a list of parameters valid for this object.

Returns:
  A reference to a static list of ParameterDef objects.

virtual Node* Ogre::MovableObject::getParentNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. Both are Node subclasses so this method will return either.

virtual SceneNode* Ogre::MovableObject::getParentSceneNode | ( | void |  | ) | const`[virtual, inherited]`

Returns the scene node to which this object is attached.

Remarks:
  A MovableObject may be attached to either a SceneNode or to a TagPoint, the latter case if it's attached to a bone on an animated entity. This method will return the scene node of the parent entity if the latter is true.

Particle* Ogre::ParticleSystem::getParticle | ( | size_t | index | ) |

Retrieve a particle from the system for manual tweaking.

Remarks:
  Normally you use an affector to alter particles in flight, but for small manually controlled particle systems you might want to use this method.

size_t Ogre::ParticleSystem::getParticleQuota | ( | void |  | ) | const

Returns the maximum number of particles this system is allowed to have active at once.

Remarks:
  See ParticleSystem::setParticleQuota for more info.

virtual Real Ogre::ShadowCaster::getPointExtrusionDistance | ( | const Light * | l | ) | const`[pure virtual, inherited]`

Get the distance to extrude for a point/spot light.

Real Ogre::MovableObject::getPointExtrusionDistance | ( | const Light * | l | ) | const`[inherited]`

Get the distance to extrude for a point/spot light.

virtual uint32 Ogre::MovableObject::getQueryFlags | ( | void |  | ) | const`[virtual, inherited]`

Returns the query flags relevant for this object.

Reimplemented in Ogre::TerrainQuadTreeNode::Movable.

Definition at line 384 of file OgreMovableObject.h.

bool Ogre::MovableObject::getReceivesShadows | ( |  | ) | `[inherited]`

Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.

ParticleSystemRenderer* Ogre::ParticleSystem::getRenderer | ( | void |  | ) | const

Gets the ParticleRenderer to be used to render this particle system.

const String& Ogre::ParticleSystem::getRendererName | ( | void |  | ) | const

Gets the name of the ParticleRenderer to be used to render this particle system.

virtual Real Ogre::MovableObject::getRenderingDistance | ( | void |  | ) | const`[virtual, inherited]`

Gets the distance at which batches are no longer rendered.

Definition at line 301 of file OgreMovableObject.h.

virtual uint8 Ogre::MovableObject::getRenderQueueGroup | ( | void |  | ) | const`[virtual, inherited]`

Gets the queue group for this entity, see setRenderQueueGroup for full details.

virtual const String& Ogre::ParticleSystem::getResourceGroupName | ( | void |  | ) | const`[virtual]`

Return the resource group to be used to load dependent resources.

Definition at line 537 of file OgreParticleSystem.h.

ShadowRenderableListIterator Ogre::MovableObject::getShadowVolumeRenderableIterator | ( | ShadowTechnique | shadowTechnique,
|  | const Light * | light,
|  | HardwareIndexBufferSharedPtr * | indexBuffer,
|  | bool | extrudeVertices,
|  | Real | extrusionDist,
|  | unsigned long | flags = `0` |
| ) |  |  | `[inherited]`

Define a default implementation of method from ShadowCaster which implements no shadows.

Reimplemented in Ogre::ManualObject, and Ogre::StaticGeometry::Region.

virtual ShadowRenderableListIterator Ogre::ShadowCaster::getShadowVolumeRenderableIterator | ( | ShadowTechnique | shadowTechnique,
|  | const Light * | light,
|  | HardwareIndexBufferSharedPtr * | indexBuffer,
|  | bool | extrudeVertices,
|  | Real | extrusionDistance,
|  | unsigned long | flags = `0` |
| ) |  |  | `[pure virtual, inherited]`

Gets an iterator over the renderables required to render the shadow volume.

Remarks:
  Shadowable geometry should ideally be designed such that there is only one ShadowRenderable required to render the the shadow; however this is not a necessary limitation and it can be exceeded if required.

Parameters:

  | shadowTechnique | The technique being used to generate the shadow
  | light | The light to generate the shadow from
  | indexBuffer | The index buffer to build the renderables into, the current contents are assumed to be disposable.
  | extrudeVertices | If true, this means this class should extrude the vertices of the back of the volume in software. If false, it will not be done (a vertex program is assumed).
  | extrusionDistance | The distance to extrude the shadow volume
  | flags | Technique-specific flags, see ShadowRenderableFlags

bool Ogre::ParticleSystem::getSortingEnabled | ( | void |  | ) | const

Gets whether particles are sorted relative to the camera.

Definition at line 559 of file OgreParticleSystem.h.

Real Ogre::ParticleSystem::getSpeedFactor | ( | void |  | ) | const

Gets the 'speed factor' on this particle system.

Definition at line 422 of file OgreParticleSystem.h.

uint32 Ogre::ParticleSystem::getTypeFlags | ( | void |  | ) | const`[virtual]`

Override to return specific type flag.

Reimplemented from Ogre::MovableObject.

virtual const Any& Ogre::MovableObject::getUserAny | ( | void |  | ) | const`[virtual, inherited]`

Deprecated:
  use UserObjectBindings::getUserAny via getUserObjectBindings() instead.

Retrieves the custom user value associated with this object.

Definition at line 315 of file OgreMovableObject.h.

const UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) | const`[inherited]`

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also:
  UserObjectBindings::setUserAny.

Definition at line 327 of file OgreMovableObject.h.

UserObjectBindings& Ogre::MovableObject::getUserObjectBindings | ( |  | ) | `[inherited]`

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also:
  UserObjectBindings::setUserAny.

Definition at line 321 of file OgreMovableObject.h.

virtual uint32 Ogre::MovableObject::getVisibilityFlags | ( | void |  | ) | const`[virtual, inherited]`

Returns the visibility flags relevant for this object.

Reimplemented in Ogre::TerrainQuadTreeNode::Movable.

Definition at line 412 of file OgreMovableObject.h.

virtual bool Ogre::MovableObject::getVisible | ( | void |  | ) | const`[virtual, inherited]`

Gets this object whether to be visible or not, if it has a renderable component.

Remarks:
  Returns the value set by MovableObject::setVisible only.

virtual const AxisAlignedBox& Ogre::ShadowCaster::getWorldBoundingBox | ( | bool | derive = `false` | ) | const`[pure virtual, inherited]`

Get the world bounding box of the caster.

virtual const AxisAlignedBox& Ogre::MovableObject::getWorldBoundingBox | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

Retrieves the axis-aligned bounding box for this object in world coordinates.

virtual const Sphere& Ogre::MovableObject::getWorldBoundingSphere | ( | bool | derive = `false` | ) | const`[virtual, inherited]`

Retrieves the worldspace bounding sphere for this object.

bool Ogre::MovableObject::hasEdgeList | ( | void |  | ) | `[inherited]`

Define a default implementation of method from ShadowCaster which implements no shadows.

Reimplemented in Ogre::ManualObject, and Ogre::StaticGeometry::Region.

Definition at line 477 of file OgreMovableObject.h.

virtual bool Ogre::ShadowCaster::hasEdgeList | ( | void |  | ) | `[pure virtual, inherited]`

Returns whether the object has a valid edge list.

void Ogre::ParticleSystem::increaseEmittedEmitterPool | ( | size_t | size | ) | `[protected]`

Resize the internal pool of emitted emitters.

Remarks:
  The pool consists of multiple vectors containing pointers to particle emitters. Increasing the pool with size implies that the vectors are equally increased. The quota of emitted emitters is defined on a particle system level and not on a particle emitter level. This is to prevent that the number of created emitters becomes too high; the quota is shared amongst the emitted emitters.

void Ogre::ParticleSystem::increasePool | ( | size_t | size | ) | `[protected]`

Resize the internal pool of particles.

virtual void Ogre::AnimableObject::initialiseAnimableDictionary | ( | StringVector & |  | ) | const`[protected, virtual, inherited]`

Internal method for initialising dictionary; should be implemented by subclasses wanting to expose animable parameters.

Definition at line 286 of file OgreAnimable.h.

void Ogre::ParticleSystem::initialiseEmittedEmitterPool | ( | void |  | ) | `[protected]`

Determine which emitters in the Particle Systems main emitter become a template for creating an pool of emitters that can be emitted.

void Ogre::ParticleSystem::initialiseEmittedEmitters | ( | void |  | ) | `[protected]`

Create a pool of emitted emitters and assign them to the free emitter list.

Remarks:
  The emitters in the pool are grouped by name. This name is the name of the base emitter in the main list with particle emitters, which forms the template of the created emitted emitters.

void Ogre::ParticleSystem::initParameters | ( | void |  | ) | `[protected]`

Internal method for initialising string interface.

virtual bool Ogre::MovableObject::isAttached | ( | void |  | ) | const`[virtual, inherited]`

Returns true if this object is attached to a SceneNode or TagPoint.

virtual bool Ogre::MovableObject::isDebugDisplayEnabled | ( | void |  | ) | const`[virtual, inherited]`

Gets whether debug display of this object is enabled.

Definition at line 546 of file OgreMovableObject.h.

virtual bool Ogre::MovableObject::isInScene | ( | void |  | ) | const`[virtual, inherited]`

Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.

virtual bool Ogre::MovableObject::isParentTagPoint | ( |  | ) | const`[virtual, inherited]`

Gets whether the parent node is a TagPoint (or a SceneNode).

Definition at line 213 of file OgreMovableObject.h.

virtual bool Ogre::MovableObject::isVisible | ( | void |  | ) | const`[virtual, inherited]`

Returns whether or not this object is supposed to be visible or not.

Remarks:
  Takes into account both upper rendering distance and visible flag.

Reimplemented in Ogre::InstancedGeometry::BatchInstance, Ogre::StaticGeometry::Region, and Ogre::TerrainQuadTreeNode::Movable.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 107 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) | `[inherited]`

Definition at line 95 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |  |
| ) |  |  | `[inherited]`

Definition at line 101 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) | `[inherited]`

Definition at line 112 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |  |
| ) |  |  | `[inherited]`

Definition at line 118 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

operator new, with debug line info

Definition at line 67 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr |
| ) |  |  | `[inherited]`

placement operator new

Definition at line 78 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) | `[inherited]`

Definition at line 72 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) | `[inherited]`

Definition at line 90 of file OgreMemoryAllocatedObject.h.

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func |
| ) |  |  | `[inherited]`

array operator new, with debug line info

Definition at line 85 of file OgreMemoryAllocatedObject.h.

ParticleSystem& Ogre::ParticleSystem::operator= | ( | const ParticleSystem & | rhs | ) |

Assignment operator for copying.

Remarks:
  This operator deep copies all particle emitters and effectors, but not particles. The system's name is also not copied.

virtual const LightList& Ogre::MovableObject::queryLights | ( | void |  | ) | const`[virtual, inherited]`

Gets a list of lights, ordered relative to how close they are to this movable object.

Remarks:
  By default, this method gives the listener a chance to populate light list first, if there is no listener or Listener::objectQueryLights returns NULL, it'll query the light list from parent entity if it is present, or returns SceneNode::findLights if it has parent scene node, otherwise it just returns an empty list.

  The object internally caches the light list, so it will recalculate it only when object is moved, or lights that affect the frustum have been changed (

See also:
  SceneManager::_getLightsDirtyCounter), but if listener exists, it will be called each time, so the listener should implement their own cache mechanism to optimise performance.

  This method can be useful when implementing Renderable::getLights in case the renderable is a part of the movable.

Returns:
  The list of lights use to lighting this object.

void Ogre::ParticleSystem::removeAffector | ( | unsigned short | index | ) |

Removes an affector from the system.

Remarks:
  Drops the affector with the index specified from this system. You should check how many affectors are registered against this system before calling this method with an arbitrary index using getNumAffectors.

Parameters:

  | index | Zero-based index of the affector to retrieve.

void Ogre::ParticleSystem::removeAllAffectors | ( | void |  | ) |

Removes all the affectors from this system.

void Ogre::ParticleSystem::removeAllEmittedEmitters | ( | void |  | ) | `[protected]`

Removes all emitted emitters from this system.

void Ogre::ParticleSystem::removeAllEmitters | ( | void |  | ) |

Removes all the emitters from this system.

void Ogre::ParticleSystem::removeEmitter | ( | unsigned short | index | ) |

Removes an emitter from the system.

Remarks:
  Drops the emitter with the index specified from this system. You should check how many emitters are registered against this system before calling this method with an arbitrary index using getNumEmitters.

Parameters:

  | index | Zero-based index of the emitter to retrieve.

void Ogre::ParticleSystem::removeFromActiveEmittedEmitters | ( | ParticleEmitter * | emitter | ) | `[protected]`

Removes an emitter from the active emitted emitter list.

Remarks:
  The emitter will not be destroyed!

Parameters:

  | emitter | Pointer to a particle emitter.

virtual void Ogre::MovableObject::removeQueryFlags | ( | unsigned long | flags | ) | `[virtual, inherited]`

As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.

Definition at line 381 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::removeVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.

Definition at line 409 of file OgreMovableObject.h.

void Ogre::ParticleSystem::setBounds | ( | const AxisAlignedBox & | aabb | ) |

Set the (initial) bounds of the particle system manually.

Remarks:
  If you can, set the bounds of a particle system up-front and call setBoundsAutoUpdated(false); this is the most efficient way to organise it. Otherwise, set an initial bounds and let the bounds increase for a little while (the default is 5 seconds), after which time the AABB is fixed to save time.

Parameters:

  | aabb | Bounds in local space.

void Ogre::ParticleSystem::setBoundsAutoUpdated | ( | bool | autoUpdate,
|  | Real | stopIn = `0.0f` |
| ) |  |  |

Sets whether the bounds will be automatically updated for the life of the particle system.

Remarks:
  If you have a stationary particle system, it would be a good idea to call this method and set the value to 'false', since the maximum bounds of the particle system will eventually be static. If you do this, you can either set the bounds manually using the setBounds() method, or set the second parameter of this method to a positive number of seconds, so that the bounds are calculated for a few seconds and then frozen.

Parameters:

  | autoUpdate | If true (the default), the particle system will update it's bounds every frame. If false, the bounds update will cease after the 'stopIn' number of seconds have passed.
  | stopIn | Only applicable if the first parameter is true, this is the number of seconds after which the automatic update will cease.

void Ogre::MovableObject::setCastShadows | ( | bool | enabled | ) | `[inherited]`

Sets whether or not this object will cast shadows.

Remarks:
  This setting simply allows you to turn on/off shadows for a given object. An object will not cast shadows unless the scene supports it in any case (see SceneManager::setShadowTechnique), and also the material which is in use must also have shadow casting enabled. By default all entities cast shadows. If, however, for some reason you wish to disable this for a single object then you can do so using this method.

Note:
  This method normally refers to objects which block the light, but since Light is also a subclass of MovableObject, in that context it means whether the light causes shadows itself.

Definition at line 500 of file OgreMovableObject.h.

virtual void Ogre::ParticleSystem::setCullIndividually | ( | bool | cullIndividual | ) | `[virtual]`

Sets whether culling tests particles in this individually as well as in a group.

Remarks:
  Particle sets are always culled as a whole group, based on a bounding box which encloses all particles in the set. For fairly localised sets, this is enough. However, you can optionally tell the set to also cull individual particles in the set, i.e. to test each individual particle before rendering. The default is not to do this.

  This is useful when you have a large, fairly distributed set of particles, like maybe trees on a landscape. You probably still want to group them into more than one set (maybe one set per section of landscape), which will be culled coarsely, but you also want to cull the particles individually because they are spread out. Whilst you could have lots of single-tree sets which are culled separately, this would be inefficient to render because each tree would be issued as it's own rendering operation.

  By calling this method with a parameter of true, you can have large particle sets which are spaced out and so get the benefit of batch rendering and coarse culling, but also have fine-grained culling so unnecessary rendering is avoided.

Parameters:

  | cullIndividual | If true, each particle is tested before being sent to the pipeline as well as the whole set having to pass the coarse group bounding test.

virtual void Ogre::MovableObject::setDebugDisplayEnabled | ( | bool | enabled | ) | `[virtual, inherited]`

Sets whether or not the debug display of this object is enabled.

Remarks:
  Some objects aren't visible themselves but it can be useful to display a debug representation of them. Or, objects may have an additional debug display on top of their regular display. This option enables / disables that debug display. Objects that are not visible never display debug geometry regardless of this setting.

Definition at line 544 of file OgreMovableObject.h.

virtual void Ogre::ParticleSystem::setDefaultDimensions | ( | Real | width,
|  | Real | height |
| ) |  |  | `[virtual]`

Sets the default dimensions of the particles in this set.

Remarks:
  All particles in a set are created with these default dimensions. The set will render most efficiently if all the particles in the set are the default size. It is possible to alter the size of individual particles at the expense of extra calculation. See the Particle class for more info.

Parameters:

  | width | The new default width for the particles in this set.
  | height | The new default height for the particles in this set.

virtual void Ogre::ParticleSystem::setDefaultHeight | ( | Real | height | ) | `[virtual]`

See setDefaultDimensions - this sets 1 component individually.

static void Ogre::ParticleSystem::setDefaultIterationInterval | ( | Real | iterationInterval | ) | `[static]`

Set the default iteration interval for all ParticleSystem instances.

Definition at line 447 of file OgreParticleSystem.h.

static void Ogre::ParticleSystem::setDefaultNonVisibleUpdateTimeout | ( | Real | timeout | ) | `[static]`

Set the default nonvisible timeout for all ParticleSystem instances.

Definition at line 475 of file OgreParticleSystem.h.

static void Ogre::MovableObject::setDefaultQueryFlags | ( | uint32 | flags | ) | `[static, inherited]`

Set the default query flags for all future MovableObject instances.

Definition at line 388 of file OgreMovableObject.h.

static void Ogre::MovableObject::setDefaultVisibilityFlags | ( | uint32 | flags | ) | `[static, inherited]`

Set the default visibility flags for all future MovableObject instances.

Definition at line 416 of file OgreMovableObject.h.

virtual void Ogre::ParticleSystem::setDefaultWidth | ( | Real | width | ) | `[virtual]`

See setDefaultDimensions - this sets 1 component individually.

void Ogre::ParticleSystem::setEmittedEmitterQuota | ( | size_t | quota | ) |

Sets the maximum number of emitted emitters this system is allowed to have active at once.

Remarks:
  Particle systems can have - besides a particle quota - also an emitted emitter quota.

Parameters:

  | quota | The maximum number of emitted emitters this system is allowed to have.

void Ogre::ParticleSystem::setEmitting | ( | bool | v | ) |

This is used to turn on or off particle emission for this system.

Remarks:
  By default particle system is always emitting particles (if a emitters exists) and this can be used to stop the emission for all emitters. To turn it on again, call it passing true.

Note that this does not detach the particle system from the scene node, it will still use some CPU.

void Ogre::ParticleSystem::setIterationInterval | ( | Real | iterationInterval | ) |

Sets a 'iteration interval' on this particle system.

Remarks:
  The default Particle system update interval, based on elapsed frame time, will cause different behavior between low frame-rate and high frame-rate. By using this option, you can make the particle system update at a fixed interval, keeping the behavior the same no matter what frame-rate is.

  When iteration interval is set to zero, it means the update occurs based on an elapsed frame time, otherwise each iteration will take place at the given interval, repeating until it has used up all the elapsed frame time.

Parameters:

  | iterationInterval | The iteration interval, default to zero.

void Ogre::ParticleSystem::setKeepParticlesInLocalSpace | ( | bool | keepLocal | ) |

Sets whether particles (and any affector effects) remain relative to the node the particle system is attached to.

Remarks:
  By default particles are in world space once emitted, so they are not affected by movement in the parent node of the particle system. This makes the most sense when dealing with completely independent particles, but if you want to constrain them to follow local motion too, you can set this to true.

virtual void Ogre::MovableObject::setLightMask | ( | uint32 | lightMask | ) | `[virtual, inherited]`

Set a bitwise mask which will filter the lights affecting this object.

Remarks:
  This mask will be compared against the mask held against Light to determine if a light should affect a given object. By default, this mask is fully set meaning all lights will affect this object

virtual void Ogre::MovableObject::setListener | ( | Listener * | listener | ) | `[virtual, inherited]`

Sets a listener for this object.

Remarks:
  Note for size and performance reasons only one listener per object is allowed.

Definition at line 427 of file OgreMovableObject.h.

virtual void Ogre::ParticleSystem::setMaterialName | ( | const String & | name,
|  | const String & | groupName = `ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME` |
| ) |  |  | `[virtual]`

Sets the name of the material to be used for this billboard set.

Parameters:

  | name | The new name of the material to use for this set.

void Ogre::ParticleSystem::setNonVisibleUpdateTimeout | ( | Real | timeout | ) |

Sets when the particle system should stop updating after it hasn't been visible for a while.

Remarks:
  By default, visible particle systems update all the time, even when not in view. This means that they are guaranteed to be consistent when they do enter view. However, this comes at a cost, updating particle systems can be expensive, especially if they are perpetual.

  This option lets you set a 'timeout' on the particle system, so that if it isn't visible for this amount of time, it will stop updating until it is next visible.

Parameters:

  | timeout | The time after which the particle system will be disabled if it is no longer visible. 0 to disable the timeout and always update.

virtual bool Ogre::StringInterface::setParameter | ( | const String & | name,
|  | const String & | value |
| ) |  |  | `[virtual, inherited]`

Generic parameter setting method.

Remarks:
  Call this method with the name of a parameter and a string version of the value to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | name | The name of the parameter to set
  | value | String value. Must be in the right format for the type specified in the parameter definition. See the StringConverter class for more information.

Returns:
  true if set was successful, false otherwise (NB no exceptions thrown - tolerant method)

Referenced by Ogre::StringInterface::copyParametersTo().

virtual void Ogre::StringInterface::setParameterList | ( | const NameValuePairList & | paramList | ) | `[virtual, inherited]`

Generic multiple parameter setting method.

Remarks:
  Call this method with a list of name / value pairs to set. The implementor will convert the string to a native type internally. If in doubt, check the parameter definition in the list returned from StringInterface::getParameters.

Parameters:

  | paramList | Name/value pair list

void Ogre::ParticleSystem::setParticleQuota | ( | size_t | quota | ) |

Sets the maximum number of particles this system is allowed to have active at once.

Remarks:
  Particle systems all have a particle quota, i.e. a maximum number of particles they are allowed to have active at a time. This allows the application to set a keep particle systems under control should they be affected by complex parameters which alter their emission rates etc. If a particle system reaches it's particle quota, none of the emitters will be able to emit any more particles. As existing particles die, the spare capacity will be allocated equally across all emitters to be as consistent to the origina particle system style as possible.

Parameters:

  | quota | The maximum number of particles this system is allowed to have.

virtual void Ogre::MovableObject::setQueryFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the query flags for this object.

Remarks:
  When performing a scene query, this object will be included or excluded according to flags on the object and flags on the query. This is a bitwise value, so only when a bit on these flags is set, will it be included in a query asking for that flag. The meaning of the bits is application-specific.

Definition at line 373 of file OgreMovableObject.h.

void Ogre::ParticleSystem::setRenderer | ( | const String & | typeName | ) |

Sets the ParticleRenderer to be used to render this particle system.

Remarks:
  The main ParticleSystem just manages the creation and movement of particles; they are rendered using functions in ParticleRenderer and the ParticleVisual instances they create.

Parameters:

  | typeName | String identifying the type of renderer to use; a new instance of this type will be created; a factory must have been registered with ParticleSystemManager.

virtual void Ogre::MovableObject::setRenderingDistance | ( | Real | dist | ) | `[virtual, inherited]`

Sets the distance at which the object is no longer rendered.

Parameters:

  | dist | Distance beyond which the object will not be rendered (the default is 0, which means objects are always rendered).

Definition at line 295 of file OgreMovableObject.h.

void Ogre::ParticleSystem::setRenderQueueGroup | ( | uint8 | queueID | ) | `[virtual]`

Sets the render queue group this entity will be rendered through.

Remarks:
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. If you do not call this method, all Entity objects default to the default queue (RenderQueue::getDefaultQueueGroup), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters:

  | queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.

Reimplemented from Ogre::MovableObject.

virtual void Ogre::MovableObject::setRenderQueueGroupAndPriority | ( | uint8 | queueID,
|  | ushort | priority |
| ) |  |  | `[virtual, inherited]`

Sets the render queue group and group priority this entity will be rendered through.

Remarks:
  Render queues are grouped to allow you to more tightly control the ordering of rendered objects. Within a single render group there another type of grouping called priority which allows further control. If you do not call this method, all Entity objects default to the default queue and priority (RenderQueue::getDefaultQueueGroup, RenderQueue::getDefaultRenderablePriority), which is fine for most objects. You may want to alter this if you want this entity to always appear in front of other objects, e.g. for a 3D menu system or such.

  See RenderQueue for more details.

Parameters:

  | queueID | Enumerated value of the queue group to use. See the enum RenderQueueGroupID for what kind of values can be used here.
  | priority | The priority within a group to use.

void Ogre::ParticleSystem::setSortingEnabled | ( | bool | enabled | ) |

Set whether or not particles are sorted according to the camera.

Remarks:
  Enabling sorting alters the order particles are sent to the renderer. When enabled, particles are sent to the renderer in order of furthest distance from the camera.

Definition at line 557 of file OgreParticleSystem.h.

void Ogre::ParticleSystem::setSpeedFactor | ( | Real | speedFactor | ) |

Sets a 'speed factor' on this particle system, which means it scales the elapsed real time which has passed by this factor before passing it to the emitters, affectors, and the particle life calculation.

Remarks:
  An interesting side effect - if you want to create a completely manual particle system where you control the emission and life of particles yourself, you can set the speed factor to 0.0f, thus disabling normal particle emission, alteration, and death.

Definition at line 418 of file OgreParticleSystem.h.

virtual void Ogre::MovableObject::setUserAny | ( | const Any & | anything | ) | `[virtual, inherited]`

Deprecated:
  use UserObjectBindings::setUserAny via getUserObjectBindings() instead.

Sets any kind of user value on this object.

Remarks:
  This method allows you to associate any user value you like with this MovableObject. This can be a pointer back to one of your own classes for instance.

Definition at line 310 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setVisibilityFlags | ( | uint32 | flags | ) | `[virtual, inherited]`

Sets the visiblity flags for this object.

Remarks:
  As well as a simple true/false value for visibility (as seen in setVisible), you can also set visiblity flags which when 'and'ed with the SceneManager's visibility mask can also make an object invisible.

Definition at line 401 of file OgreMovableObject.h.

virtual void Ogre::MovableObject::setVisible | ( | bool | visible | ) | `[virtual, inherited]`

Tells this object whether to be visible or not, if it has a renderable component.

Note:
  An alternative approach of making an object invisible is to detach it from it's SceneNode, or to remove the SceneNode entirely. Detaching a node means that structurally the scene graph changes. Once this change has taken place, the objects / nodes that have been removed have less overhead to the visibility detection pass than simply making the object invisible, so if you do this and leave the objects out of the tree for a long time, it's faster. However, the act of detaching / reattaching nodes is in itself more expensive than setting an object visibility flag, since in the latter case structural changes are not made. Therefore, small or frequent visibility changes are best done using this method; large or more longer term changes are best done by detaching.

Reimplemented in Ogre::Light.

virtual void Ogre::ShadowCaster::updateEdgeListLightFacing | ( | EdgeData * | edgeData,
|  | const Vector4 & | lightPos |
| ) |  |  | `[protected, virtual, inherited]`

Tells the caster to perform the tasks necessary to update the edge data's light listing.

Can be overridden if the subclass needs to do additional things.

Parameters:

  | edgeData | The edge information to update
  | lightPos | 4D vector representing the light, a directional light has w=0.0

void Ogre::ParticleSystem::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = `false` |
| ) |  |  | `[virtual]`

Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.

Parameters:

  | visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  | debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.

Implements Ogre::MovableObject.

## Member Data Documentation

AxisAlignedBox Ogre::ParticleSystem::mAABB`[protected]`

Definition at line 657 of file OgreParticleSystem.h.

ActiveEmittedEmitterList Ogre::ParticleSystem::mActiveEmittedEmitters`[protected]`

Active emitted emitter list.

Remarks:
  This is a linked list of pointers to emitters in the emitted emitter pool. Emitters that are used are stored (their pointers) in both the list with active particles and in the list with active emitted emitters.

Definition at line 784 of file OgreParticleSystem.h.

ActiveParticleList Ogre::ParticleSystem::mActiveParticles`[protected]`

Active particle list.

Remarks:
  This is a linked list of pointers to particles in the particle pool.

  This allows very fast insertions and deletions from anywhere in the list to activate / deactivate particles as well as reuse of Particle instances in the pool without construction & destruction which avoids memory thrashing.

Definition at line 738 of file OgreParticleSystem.h.

ParticleAffectorList Ogre::ParticleSystem::mAffectors`[protected]`

List of particle affectors, ie modifiers of particles.

Definition at line 792 of file OgreParticleSystem.h.

bool Ogre::MovableObject::mBeyondFarDistance`[protected, inherited]`

Hidden because of distance?

Definition at line 125 of file OgreMovableObject.h.

Real Ogre::ParticleSystem::mBoundingRadius`[protected]`

Definition at line 658 of file OgreParticleSystem.h.

bool Ogre::ParticleSystem::mBoundsAutoUpdate`[protected]`

Definition at line 659 of file OgreParticleSystem.h.

Real Ogre::ParticleSystem::mBoundsUpdateTime`[protected]`

Definition at line 660 of file OgreParticleSystem.h.

bool Ogre::MovableObject::mCastShadows`[protected, inherited]`

Does this object cast shadows?

Definition at line 147 of file OgreMovableObject.h.

MovableObjectFactory* Ogre::MovableObject::mCreator`[protected, inherited]`

Creator of this object (if created by a factory).

Definition at line 111 of file OgreMovableObject.h.

bool Ogre::ParticleSystem::mCullIndividual`[protected]`

Do we cull each particle individually?

Definition at line 798 of file OgreParticleSystem.h.

bool Ogre::MovableObject::mDebugDisplay`[protected, inherited]`

Is debug display enabled?

Definition at line 120 of file OgreMovableObject.h.

Real Ogre::ParticleSystem::mDefaultHeight`[protected]`

Default height of each particle.

Definition at line 677 of file OgreParticleSystem.h.

Real Ogre::ParticleSystem::mDefaultWidth`[protected]`

Default width of each particle.

Definition at line 675 of file OgreParticleSystem.h.

EmittedEmitterPool Ogre::ParticleSystem::mEmittedEmitterPool`[protected]`

Pool of emitted emitters for use and reuse in the active emitted emitter list.

Remarks:
  The emitters in this pool act as particles and as emitters. The pool is a map containing lists of emitters, identified by their name.

  The emitters in this pool are cloned using emitters that are kept in the main emitter list of the ParticleSystem.

Definition at line 771 of file OgreParticleSystem.h.

bool Ogre::ParticleSystem::mEmittedEmitterPoolInitialised`[protected]`

Indication whether the emitted emitter pool (= pool with particle emitters that are emitted) is initialised.

Definition at line 699 of file OgreParticleSystem.h.

size_t Ogre::ParticleSystem::mEmittedEmitterPoolSize`[protected]`

The number of emitted emitters in the pool.

Definition at line 807 of file OgreParticleSystem.h.

ParticleEmitterList Ogre::ParticleSystem::mEmitters`[protected]`

List of particle emitters, ie sources of particles.

Definition at line 790 of file OgreParticleSystem.h.

FreeEmittedEmitterMap Ogre::ParticleSystem::mFreeEmittedEmitters`[protected]`

Free emitted emitter list.

Remarks:
  This contains a list of the emitters free for use as new instances as required by the set.

Definition at line 777 of file OgreParticleSystem.h.

FreeParticleList Ogre::ParticleSystem::mFreeParticles`[protected]`

Free particle queue.

Remarks:
  This contains a list of the particles free for use as new instances as required by the set. Particle instances are preconstructed up to the estimated size in the mParticlePool vector and are referenced on this deque at startup. As they get used this list reduces, as they get released back to to the set they get added back to the list.

Definition at line 749 of file OgreParticleSystem.h.

bool Ogre::ParticleSystem::mIsEmitting`[protected]`

Used to control if the particle system should emit particles or not.

Definition at line 701 of file OgreParticleSystem.h.

bool Ogre::ParticleSystem::mIsRendererConfigured`[protected]`

Have we set the material etc on the renderer?

Definition at line 671 of file OgreParticleSystem.h.

Real Ogre::ParticleSystem::mIterationInterval`[protected]`

Iteration interval.

Definition at line 681 of file OgreParticleSystem.h.

bool Ogre::ParticleSystem::mIterationIntervalSet`[protected]`

Iteration interval set? Otherwise track default.

Definition at line 683 of file OgreParticleSystem.h.

unsigned long Ogre::ParticleSystem::mLastVisibleFrame`[protected]`

Last frame in which known to be visible.

Definition at line 695 of file OgreParticleSystem.h.

LightList Ogre::MovableObject::mLightList`[mutable, protected, inherited]`

List of lights for this object.

Reimplemented in Ogre::StaticGeometry::Region.

Definition at line 155 of file OgreMovableObject.h.

ulong Ogre::MovableObject::mLightListUpdated`[mutable, protected, inherited]`

The last frame that this light list was updated in.

Reimplemented in Ogre::StaticGeometry::Region.

Definition at line 157 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::mLightMask`[protected, inherited]`

the light mask defined for this movable. This will be taken into consideration when deciding which light should affect this movable

Definition at line 160 of file OgreMovableObject.h.

Listener* Ogre::MovableObject::mListener`[protected, inherited]`

MovableObject listener - only one allowed (no list) for size & performance reasons. */.

Definition at line 152 of file OgreMovableObject.h.

bool Ogre::ParticleSystem::mLocalSpace`[protected]`

Particles in local space?

Definition at line 687 of file OgreParticleSystem.h.

SceneManager* Ogre::MovableObject::mManager`[protected, inherited]`

SceneManager holding this object (if applicable).

Definition at line 113 of file OgreMovableObject.h.

String Ogre::ParticleSystem::mMaterialName`[protected]`

Name of the material to use.

Definition at line 669 of file OgreParticleSystem.h.

String Ogre::MovableObject::mName`[protected, inherited]`

Name of this object.

Definition at line 109 of file OgreMovableObject.h.

Real Ogre::ParticleSystem::mNonvisibleTimeout`[protected]`

Update timeout when nonvisible (0 for no timeout).

Definition at line 689 of file OgreParticleSystem.h.

bool Ogre::ParticleSystem::mNonvisibleTimeoutSet`[protected]`

Update timeout when nonvisible set? Otherwise track default.

Definition at line 691 of file OgreParticleSystem.h.

String Ogre::ParticleSystem::mOrigin`[protected]`

Optional origin of this particle system (eg script name).

Definition at line 810 of file OgreParticleSystem.h.

bool Ogre::MovableObject::mParentIsTagPoint`[protected, inherited]`

Definition at line 116 of file OgreMovableObject.h.

Node* Ogre::MovableObject::mParentNode`[protected, inherited]`

node to which this object is attached

Definition at line 115 of file OgreMovableObject.h.

ParticlePool Ogre::ParticleSystem::mParticlePool`[protected]`

Pool of particle instances for use and reuse in the active particle list.

Remarks:
  This vector will be preallocated with the estimated size of the set,and will extend as required.

Definition at line 755 of file OgreParticleSystem.h.

MaterialPtr Ogre::ParticleSystem::mpMaterial`[protected]`

Pointer to the material to use.

Definition at line 673 of file OgreParticleSystem.h.

size_t Ogre::ParticleSystem::mPoolSize`[protected]`

The number of particles in the pool.

Definition at line 804 of file OgreParticleSystem.h.

uint32 Ogre::MovableObject::mQueryFlags`[protected, inherited]`

Flags determining whether this object is included / excluded from scene queries.

Definition at line 137 of file OgreMovableObject.h.

RadixSort<ActiveParticleList, Particle*, float> Ogre::ParticleSystem::mRadixSorter`[static, protected]`

Definition at line 727 of file OgreParticleSystem.h.

ParticleSystemRenderer* Ogre::ParticleSystem::mRenderer`[protected]`

The renderer used to render this particle system.

Definition at line 795 of file OgreParticleSystem.h.

String Ogre::ParticleSystem::mRendererType`[protected]`

The name of the type of renderer used to render this system.

Definition at line 801 of file OgreParticleSystem.h.

bool Ogre::MovableObject::mRenderingDisabled`[protected, inherited]`

Does rendering this object disabled by listener?

Definition at line 150 of file OgreMovableObject.h.

uint8 Ogre::MovableObject::mRenderQueueID`[protected, inherited]`

The render queue to use when rendering this object.

Definition at line 129 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderQueueIDSet`[protected, inherited]`

Flags whether the RenderQueue's default should be used.

Definition at line 131 of file OgreMovableObject.h.

ushort Ogre::MovableObject::mRenderQueuePriority`[protected, inherited]`

The render queue group to use when rendering this object.

Definition at line 133 of file OgreMovableObject.h.

bool Ogre::MovableObject::mRenderQueuePrioritySet`[protected, inherited]`

Flags whether the RenderQueue's default should be used.

Definition at line 135 of file OgreMovableObject.h.

String Ogre::ParticleSystem::mResourceGroupName`[protected]`

Name of the resource group to use to load materials.

Definition at line 667 of file OgreParticleSystem.h.

AnimableDictionaryMap Ogre::AnimableObject::msAnimableDictionary`[static, protected, inherited]`

Static map of class name to list of animable value names.

Definition at line 242 of file OgreAnimable.h.

CmdCull Ogre::ParticleSystem::msCullCmd`[static, protected]`

Command objects.

Definition at line 644 of file OgreParticleSystem.h.

Real Ogre::ParticleSystem::msDefaultIterationInterval`[static, protected]`

Default iteration interval.

Definition at line 813 of file OgreParticleSystem.h.

Real Ogre::ParticleSystem::msDefaultNonvisibleTimeout`[static, protected]`

Default nonvisible update timeout.

Definition at line 815 of file OgreParticleSystem.h.

uint32 Ogre::MovableObject::msDefaultQueryFlags`[static, protected, inherited]`

Default query flags.

Definition at line 164 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::msDefaultVisibilityFlags`[static, protected, inherited]`

Default visibility flags.

Definition at line 166 of file OgreMovableObject.h.

CmdEmittedEmitterQuota Ogre::ParticleSystem::msEmittedEmitterQuotaCmd`[static, protected]`

Definition at line 648 of file OgreParticleSystem.h.

CmdHeight Ogre::ParticleSystem::msHeightCmd`[static, protected]`

Definition at line 645 of file OgreParticleSystem.h.

CmdIterationInterval Ogre::ParticleSystem::msIterationIntervalCmd`[static, protected]`

Definition at line 653 of file OgreParticleSystem.h.

CmdLocalSpace Ogre::ParticleSystem::msLocalSpaceCmd`[static, protected]`

Definition at line 652 of file OgreParticleSystem.h.

CmdMaterial Ogre::ParticleSystem::msMaterialCmd`[static, protected]`

Definition at line 646 of file OgreParticleSystem.h.

CmdNonvisibleTimeout Ogre::ParticleSystem::msNonvisibleTimeoutCmd`[static, protected]`

Definition at line 654 of file OgreParticleSystem.h.

bool Ogre::ParticleSystem::mSorted`[protected]`

Particles sorted according to camera?

Definition at line 685 of file OgreParticleSystem.h.

Real Ogre::ParticleSystem::mSpeedFactor`[protected]`

Speed factor.

Definition at line 679 of file OgreParticleSystem.h.

Real Ogre::MovableObject::mSquaredUpperDistance`[protected, inherited]`

Definition at line 123 of file OgreMovableObject.h.

CmdQuota Ogre::ParticleSystem::msQuotaCmd`[static, protected]`

Definition at line 647 of file OgreParticleSystem.h.

CmdRenderer Ogre::ParticleSystem::msRendererCmd`[static, protected]`

Definition at line 650 of file OgreParticleSystem.h.

CmdSorted Ogre::ParticleSystem::msSortedCmd`[static, protected]`

Definition at line 651 of file OgreParticleSystem.h.

CmdWidth Ogre::ParticleSystem::msWidthCmd`[static, protected]`

Definition at line 649 of file OgreParticleSystem.h.

Controller<Real>* Ogre::ParticleSystem::mTimeController`[protected]`

Controller for time update.

Definition at line 697 of file OgreParticleSystem.h.

Real Ogre::ParticleSystem::mTimeSinceLastVisible`[protected]`

Amount of time non-visible so far.

Definition at line 693 of file OgreParticleSystem.h.

Real Ogre::ParticleSystem::mUpdateRemainTime`[protected]`

Definition at line 661 of file OgreParticleSystem.h.

Real Ogre::MovableObject::mUpperDistance`[protected, inherited]`

Upper distance to still render.

Definition at line 122 of file OgreMovableObject.h.

UserObjectBindings Ogre::MovableObject::mUserObjectBindings`[protected, inherited]`

User objects binding.

Definition at line 127 of file OgreMovableObject.h.

uint32 Ogre::MovableObject::mVisibilityFlags`[protected, inherited]`

Flags determining whether this object is visible (compared to SceneManager mask).

Definition at line 139 of file OgreMovableObject.h.

bool Ogre::MovableObject::mVisible`[protected, inherited]`

Is this object visible?

Definition at line 118 of file OgreMovableObject.h.

AxisAlignedBox Ogre::ParticleSystem::mWorldAABB`[protected]`

World AABB, only used to compare world-space positions to calc bounds.

Reimplemented from Ogre::MovableObject.

Definition at line 664 of file OgreParticleSystem.h.

Sphere Ogre::MovableObject::mWorldBoundingSphere`[mutable, protected, inherited]`

Definition at line 143 of file OgreMovableObject.h.

AxisAlignedBox Ogre::MovableObject::mWorldDarkCapBounds`[mutable, protected, inherited]`

World space AABB of this object's dark cap.

Definition at line 145 of file OgreMovableObject.h.

The documentation for this class was generated from the following file:

- OgreParticleSystem.h

Copyright © 2008 Torus Knot Software Ltd
This work is licensed under a Creative Commons Attribution-ShareAlike 3.0 Unported License.
Last modified Wed Nov 3 2010 19:24:58